'Note: Excel class is at the bottom of this file
Imports System
Imports System.Web
Imports System.Web.UI.WebControls
Imports System.Data
Imports System.Data.OleDb
Imports Microsoft.VisualBasic

Public Class ExcelADODemo
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'The Response.Write's are not good .NET coding, but it keeps this demo simple
        Response.Write("<html><body>")

        If Not Page.IsPostBack Then
            'Demo reading and writing to an excel file.
            Dim intRow, intCol As Integer

            'Create an instance of the ExcelOLE class (located at bottom half of this file)
            'You should compile the class into an assembly. Not done here to keep the demo simple.
            Dim objExcel As New ExcelADO()

            'Open the Demo spreadsheet with error checking.
            Response.Write("<font face='arial'><b>Opening Demo Spreadsheet:</b> " & Server.MapPath("ExcelDemo.xls") & "<br>")
            objExcel.Driver = ExcelADO.DriverType.JetExcel
            If Not objExcel.OpenSpreadsheet(Server.MapPath("ExcelDemo.xls")) Then
               Response.Write(objExcel.ErrorText)
            Else
                'Display the Tables found when we opened the spreadsheet
                Response.Write("<p><b>Worksheets & Named Areas Found:</b> (worksheets have a $ after them)<br>")
                Dim intTable As Integer
                For intTable = 0 To objExcel.NumSheets - 1 'Sheets are referenced from 0 not 1
                    Response.Write(objExcel.Worksheets(intTable) & "<br>")
                Next

                'Add additional SQL criteria. If omitted, then all records are returned in default order etc
                'objExcel.SQLStatement = "where KeyCode <> 'test' order by SALUTATION"

                'Open a worksheet for reading (faster then write mode) via it's name (and a $ after as it is a worksheet) - with error checking
                Response.Write("<p><b>Opening worksheet:</b> 'Demo' (or Demo$ as the ODBC driver sees it)<br>")
                If Not objExcel.OpenWorksheet("Demo$") Then
                    Response.Write(objExcel.ErrorText & "<br>")
                Else
                    Response.Write("Open<br>")
                    'Display the Columns found when we opened the worksheet
                    Response.Write("<p><b>Columns Names and Data Found:</b><br>")
                    Response.Write("<table cellpadding='1' cellspacing='1' border='1' style='border-collapse: collapse; font-family: Arial; font-size: 10pt;' bordercolor='#111111'><tr bgcolor='#c0c0c0'>")
                    For intCol = 0 To objExcel.NumColumns - 1 'Columns are referenced from 0 not 1
                        Response.Write("<td>" & objExcel.Columns(intCol) & "</td>")
                    Next
                    Response.Write("</tr>" & vbLf)

                    'Display each data row via directly accessing the DataTable
                    For intRow = 0 To objExcel.ExcelDataTable.Rows.Count - 1
                        Response.Write("<tr>")
                        For intCol = 0 To objExcel.ExcelDataTable.Columns.Count - 1
                            Response.Write("<td>" & objExcel.ExcelDataTable.Rows(intRow).Item(intCol) & "</td>")
                        Next
                        Response.Write("</tr>" & vbLf)
                    Next
                    'or Display each data row via the ReadRow method
                    'While objExcel.ReadRow
                    '    Response.Write("</tr><tr>")
                    '    For intCol = 0 To objExcel.ExcelDataRow.Columns.Count - 1
                    '        Response.Write("<td>" & objExcel.ExcelDataRow(intCol) & "</td>")
                    '    Next
                    'End While
                    Response.Write("</table>")

                    'Close that worksheet (Opening another worksheet automatically closes the previous sheet)
                    objExcel.CloseWorksheet()

                    'Open a named space for writing via it's table index (TestName) - with error checking. Directory must be writable by IIS
                    Response.Write("<p><b>Opening Sheet2:</b><br>")
                    If Not objExcel.OpenWorksheet(objExcel.Worksheets(2)) Then
                        Response.Write(objExcel.ErrorText & "<br>")
                    Else
                        Response.Write("Open<br>")

                        'You can update an existing row (must use ReadRow first)
                        Response.Write("<p><b>Updating a row</b><br>")
                        If objExcel.ReadRow Then
                            objExcel.ExcelDataRow(2) = "updated"
                            If Not objExcel.UpdateRow() Then
                                Response.Write(objExcel.ErrorText & "<br>")
                            Else
                                Response.Write("Updated")
                            End If
                        Else
                            Response.Write(objExcel.ErrorText & "<br>")
                        End If

                        'Insert a new row
                        Response.Write("<p><b>Inserting a row</b><br>")
                        objExcel.NewRow() 'Must create new row first
                        objExcel.ExcelDataRow(0) = "Newly"
                        objExcel.ExcelDataRow(1) = "inserted"
                        objExcel.ExcelDataRow(2) = "row"

                        'Add the row back to the table (update the table)
                        If Not objExcel.InsertRow() Then
                            Response.Write(objExcel.ErrorText & "<br>")
                        Else
                            Response.Write("Inserted")
                        End If

                        'You can also directly insert the row - or do whatever
                        Response.Write("<p><b>Direct insert or row:</b> " & objExcel.SQLExecute("INSERT INTO [Sheet2$] ([KeyCode], [SALUTATION], [First NAME]) VALUES ('1', '2', '3')") & "<br>")

                        'Close the worksheet (Closing the spreadsheet will do this anyway)
                        objExcel.CloseWorksheet()
                    End If

                End If
                objExcel.CloseSpreadsheet()


            End If 'open spreadsheet
        End If 'Postback
        Response.Write("</body></html>")

    End Sub
End Class

'************************************************************************************************************************************
' ExcelADO.NET 1.02
' Excel File access via ADO Jet Excel
' Written by Hunter Beanland
Public Class ExcelADO
    Public ErrorText As String
    Public AbsoluteFileName As String
    Public Worksheets() As String
    Public Columns() As String
    Public NumSheets As Integer = 0
    Public NumColumns As Integer = 0
    Public SQLStatement As String
    Enum DriverType
        JetExcel = 0
        JetText = 1
        'ODBCExcel = 2
    End Enum
    Public Driver As DriverType = DriverType.JetExcel
    Public RowIndex As Integer = -1
    Public ExcelDataSet As DataSet
    Public ExcelDataTable As DataTable
    Public ExcelDataRow As DataRow
    Private ExcelDataRowOld() 'Disconnected DataRow of old values
    Public ExcelConnection As OleDbConnection
    Private ExcelDataAdapter As OleDbDataAdapter
    Private WorksheetOpen As String = String.Empty

    Private Function GetWorksheets()
        Dim intRow As Integer
        NumSheets = 0
        Try
            Dim SchemaTable As DataTable = ExcelConnection.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, New Object() {Nothing, Nothing, Nothing, "TABLE"})
            For intRow = 0 To SchemaTable.Rows.Count - 1
                ReDim Preserve Worksheets(NumSheets)
                Worksheets(NumSheets) = SchemaTable.Rows(intRow)!TABLE_NAME.ToString
                NumSheets = NumSheets + 1
            Next intRow
        Catch
        End Try
        If NumSheets = 0 Then
            ErrorText = "No named areas or worksheet tab names found"
            Return False
        End If
        Return True
    End Function

    Private Function GetColumns() As Boolean
        Dim intCol As Integer
        NumColumns = 0
        For intCol = 0 To ExcelDataTable.Columns.Count - 1
            ReDim Preserve Columns(NumColumns)
            Columns(NumColumns) = ExcelDataTable.Columns(intCol).ColumnName
            NumColumns = NumColumns + 1
        Next
        If NumColumns = 0 Then
            ErrorText = "No named areas or column names found"
            Return False
        End If
        Return True
    End Function

    Public Function OpenSpreadsheet(ByVal FileName As String) As Boolean
        ErrorText = String.Empty
        AbsoluteFileName = FileName
        'Default to Microsoft Jet driver
        'http://support.microsoft.com/default.aspx?scid=kb;EN-US;257819
        Dim strConnection As String
        'MSDASQL Provider is obsolete and does not have an OLE Driver. Use System.Data.Odbc namespace to use it
        'If Driver = DriverType.ODBCExcel Then
        '    ExcelConnection = New OleDbConnection("Provider=MSDASQL;Driver={Microsoft Excel Driver (*.xls)}; DBQ=" & FileName & "")
        'Other options: DriverID=278;DefaultDir=
        If Driver = DriverType.JetText Then
            strConnection = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & FileName & "; Extended Properties=""text;HDR=Yes;FMT=Delimited"""
            'More properties can be inserted into schema.ini: 
            '[filename.txt]
            'ColNameHeader = False
            'Format = TabDelimited
            'MaxScanRows = 3
            'CharacterSet=ANSI
        Else 'DriverType.JetExcel
            strConnection = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" & FileName & "; Extended Properties=Excel 8.0;"
            'HDR=No - not supported in >= MDAC 2.6 i think?
        End If
        'HttpContext.Current.Trace.Write("ExcelADO", strConnection)
        ExcelConnection = New OleDbConnection(strConnection)
        Try
            ExcelConnection.Open()
            If GetWorksheets() Then
                ErrorText = String.Empty
                Return True
            Else
                Return False
            End If
        Catch e As Exception
            ErrorText = "File Connection will not open: " & e.Message
            Return False
        End Try
        If ExcelConnection.State <> ConnectionState.Open Then
            ExcelConnection.Close()
            ErrorText = "File Connection will not open - check file path, lock status and valid Excel file"
            Return False
        End If
    End Function

    Public Function OpenWorksheet(ByVal TableName As String)
        If ExcelConnection.State <> ConnectionState.Open Then Return False
        ErrorText = String.Empty
        RowIndex = -1
        WorksheetOpen = String.Empty
        If InStr(Join(Worksheets), TableName, CompareMethod.Text) = 0 Then
            ErrorText = "Not valid named area or worksheet tab name: " & TableName
            Return False
        End If
        SQLStatement = "SELECT * FROM [" & TableName & "] " & SQLStatement
        ExcelDataSet = New DataSet()

        Try
            ExcelDataAdapter = New OleDbDataAdapter(SQLStatement, ExcelConnection)
            ExcelDataAdapter.Fill(ExcelDataSet, "DefaultTable")
            ExcelDataTable = ExcelDataSet.Tables(0)
        Catch e As Exception
            ErrorText = "Worksheet will not open - check named area or worksheet tab name is defined: " & e.Message
            Return False
        End Try

        SQLStatement = String.Empty 'reset SQL query so it is not carried forward to the next worksheet opening
        If GetColumns() Then
            WorksheetOpen = TableName
            Return True
        Else
            Return False
        End If
    End Function

    Public Function SQLExecute(ByVal SQL As String) As Integer
        'Execute a Non-Query command
        Logger.Debug(SQL, "ExcelADOCommand")
        Try
            If ExcelConnection.State = ConnectionState.Closed Then ExcelConnection.Open()
            Dim objCommand As OleDbCommand = New OleDbCommand(SQL, ExcelConnection)
            Return objCommand.ExecuteNonQuery()
        Catch e As Exception
            ErrorText = "SQLExecute error: " & e.Message
            Return 0
        End Try
    End Function

    Public Function ReadRow()
        'Read a row into the ExcelDataRow
        If WorksheetOpen = String.Empty Then Return False
        If ExcelDataTable.Rows.Count > 0 And RowIndex + 1 < ExcelDataTable.Rows.Count Then
            RowIndex += 1
            ExcelDataRow = ExcelDataTable.Rows(RowIndex)
            ExcelDataRowOld = ExcelDataTable.Rows(RowIndex).ItemArray
            Return True
        Else
            ErrorText = "BOF or EOF"
            Return False
        End If
    End Function

    Public Sub NewRow()
        'Create a new row object. Call AddRow when ready to add to the table
        If WorksheetOpen = String.Empty Then Exit Sub
        ExcelDataRow = ExcelDataSet.Tables(0).NewRow()
    End Sub

    Public Function InsertRow() As Boolean
        'Insert all values from ExcelDataRow into the worksheet
        'Call NewRow before updating ExcelDataRow
        '(OleDbCommandBuilder fails to build this command correctly, 
        'and ExcelDataAdapter.Update does not execute our command correctly, 
        'due to Primary Keys and odd table and field names, so we do it manually)
        If WorksheetOpen = String.Empty Then Return False
        Dim strSQL As String = "INSERT INTO [" & WorksheetOpen & "] ("
        Dim intCol As Integer
        For intCol = 0 To ExcelDataTable.Columns.Count - 1
            strSQL &= "[" & ExcelDataTable.Columns(intCol).ColumnName & "], "
        Next
        strSQL = Left(strSQL, Len(strSQL) - 2)
        strSQL &= ") VALUES ("
        For intCol = 0 To ExcelDataTable.Columns.Count - 1
            strSQL &= SQLConvert(ExcelDataRow(intCol)) & ", "
        Next
        strSQL = Left(strSQL, Len(strSQL) - 2) & ") "
        ExcelDataSet.Tables(0).Rows.Add(ExcelDataRow)
        If SQLExecute(strSQL) = 1 Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Function UpdateRow() As Boolean
        'Take updated values (only) from the ExcelDataRow and update the worksheet
        '(OleDbCommandBuilder fails to build this command correctly, 
        'and ExcelDataAdapter.Update does not execute our command correctly, 
        'due to Primary Keys and odd table and field names, so we do it manually)
        If WorksheetOpen = String.Empty Then Return False
        Dim strSQL As String = "UPDATE [" & WorksheetOpen & "] SET "
        Dim intCol As Integer
        Dim strValue As String
        For intCol = 0 To ExcelDataTable.Columns.Count - 1
            strValue = SQLConvert(ExcelDataRow(intCol))
            If strValue <> SQLConvert(ExcelDataRowOld(intCol)) Then
                strSQL &= "[" & ExcelDataTable.Columns(intCol).ColumnName & "]= " & _
                    strValue & ", "
            End If
        Next
        If Right(strSQL, 2) <> ", " Then Return True 'No changes
        strSQL = Left(strSQL, Len(strSQL) - 2)
        strSQL &= " WHERE "
        'No primary key, so WHERE all columns
        For intCol = 0 To ExcelDataTable.Columns.Count - 1
            If SQLConvert(ExcelDataRowOld(intCol)) <> "NULL" Then
                'Blank values read as NULL, but are not null or blank - what are they?
                strSQL &= "[" & ExcelDataTable.Columns(intCol).ColumnName & "]= " & _
                    SQLConvert(ExcelDataRowOld(intCol)) & " AND "
            End If
        Next
        If strSQL.EndsWith("WHERE ") Then
            strSQL &= "[" & ExcelDataTable.Columns(0).ColumnName & "]=NULL AND "
        End If
        strSQL = Left(strSQL, Len(strSQL) - 4)
        If SQLExecute(strSQL) > 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Function SQLConvert(ByVal strVal) As String
        'Returns sql text of null if input is null
        If IsDBNull(strVal) Then
            Return "NULL"
        Else
            Return "'" & strVal.ToString.Replace("\", "\\").Replace("'", "''") & "'"
        End If
    End Function

    Public Sub CloseWorksheet()
        'Close dataset
        If WorksheetOpen = String.Empty Then Exit Sub
        ExcelDataTable.Clear()
        ExcelDataSet.Clear()
        WorksheetOpen = String.Empty
    End Sub

    Public Sub CloseSpreadsheet()
        'Close and destroy
        Try
            If ExcelConnection.State = ConnectionState.Open Then ExcelConnection.Close()
            ExcelConnection.Dispose()
        Catch
        End Try
    End Sub

    Protected Overloads Overrides Sub Finalize()
        'Make sure it is closed (to release file locks and resources)
        CloseSpreadsheet()
        'Me.Finalize()
    End Sub

End Class
